#!/bin/bash
# generate moverani3.gif	20. February 2000	by eddy
#
# used source files:   header.lego   haus.lego   auto.lego 
###
NoImgs=50    # number of images for merging a movie #
NoCars=13    # number of running cars #
NoCols=4     # number of different highlight colours #
Distance=6.3 # distance between centre points of two cars #
Speed=$(echo "$Distance * $NoCols / $NoImgs" | bc -l) #stepsize of motion #
HousePos=32  # position of house along the way #
Car0Pos=-1   # float # initial position of leading car #
declare -a ColCycle
ColCycle[1]=blau
ColCycle[2]=gruen
ColCycle[3]=gelb
ColCycle[4]=rot
# there are more lego specific parameters in header.lego #
count=0
while true ; do
    if [ $count -ge $NoImgs ] ; then break ; fi
    if [ $count -le 9 ] ; then fname=img000$count
    elif [ $count -le 99 ] ; then fname=img00$count
    elif [ $count -le 999 ] ; then fname=img0$count
    else fname=img$count
    fi
    echo creating $fname...
    pos=$Car0Pos
    Car0Pos=$(echo "$Car0Pos - $Speed" | bc -l)
#
### inbetween this stripes all stdout goes to ~/bin/lego ###
#
    (   echo "############################################"
        echo "### this data stream is created by machine #"
        echo "### and is to be piped to ~/bin/lego       #"
	echo -n "### "; date
        cat header.lego
        echo Nullpunkt $HousePos -2 0
        cat haus.lego |\
        # awk core came with a little help from albrecht #
        awk -v col=${ColCycle[1]} 'BEGIN{ers=1}{if(ers&&index($0,"FARBE")) \
                                  {ers=0;gsub("FARBE",col);}print $0}' |\
        awk -v col=${ColCycle[2]} 'BEGIN{ers=1}{if(ers&&index($0,"FARBE")) \
                                  {ers=0;gsub("FARBE",col);}print $0}' |\
        awk -v col=${ColCycle[3]} 'BEGIN{ers=1}{if(ers&&index($0,"FARBE")) \
                                  {ers=0;gsub("FARBE",col);}print $0}' |\
        awk -v col=${ColCycle[4]} 'BEGIN{ers=1}{if(ers&&index($0,"FARBE")) \
                                  {ers=0;gsub("FARBE",col);}print $0}'
        carcount=0
        while true ; do
            if [ $carcount -ge $NoCars ] ; then break ; fi
            carcount=$(($carcount+1))
            echo Nullpunkt $pos 0 0
            ipos=$(echo $pos | awk '{ print int($1) }')
            # checks for car being in front or behind house #
            if [ $ipos -gt $(($HousePos+3)) ] ; then
                col1=weiss
                col2=grau
            else
                col1=${ColCycle[$(($carcount%$NoCols+1))]}
                col2=transparent
            fi
            echo "# auto No. "$carcount $col1
            cat auto.lego |\
            sed -e "s/FARBE1/$col1/" |\
            sed -e "s/FARBE2/$col2/"
            pos=$(echo "$pos + $Distance" | bc -l)
            done
    ) |\
#   cat > lego_in.log
#   cat   lego_in.log |\
#
### inbetween this stripes all stdout goes to ~/bin/lego ###
#
    if test -s $fname.ppm ; then
        echo $fname.ppm already exists, no need to rebuild.
    else 
#       ~/bin/lego 2> lego_out.log > $fname.ppm
        ~/bin/lego 2> /dev/null > $fname.ppm
        # display currently rendered image as background job #
        (
            tmpfname=tmp${fname}.ppm
            nice pnmscale -xysize 571 300 < $fname.ppm > $tmpfname
            xv -geometry +400+0 $tmpfname
            rm -f $tmpfname
            unset tmpfname
        ) &
    fi
    # a new ppm appeared (or already existed) #
    ipos=$(echo $Car0Pos | awk '{ print int($1) }')
    # check if leading car left scenery #
    if [ $ipos -lt -5 ] ; then
        # leading car dies, new trailing car appears, colors are turned round #
        Car0Pos=$(echo "$Car0Pos + $Distance" | bc -l)
        ColCycle[0]=${ColCycle[1]}
        ColCycle[1]=${ColCycle[2]}
        ColCycle[2]=${ColCycle[3]}
        ColCycle[3]=${ColCycle[4]}
        ColCycle[4]=${ColCycle[0]}
        # here is the bug, because only 4 colors are turned round #
    fi
    count=$(($count+1))
    done
# this is to save the result of long computing time #
tar -cvzf rawppm.tgz img*.ppm
# and now form all img????.ppm a gif animated movie is merged #
~/bin/gifani movani3
###
# of course it's buggy, but what the @#&%$ who is going to fix it?
